'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = profile;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function profile() {
  var performance = (typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object' ? window.performance : { now: function now() {
      return process.hrtime;
    } };
  return { displayName: 'Profile',
    init: function init() {
      var _this = this;

      this.__performance__ = [{ init: performance.now() }];
      this.performance = function (key) {
        return _this.__performance__.push(_defineProperty({}, key, performance.now()));
      };
      this.profile = function () {
        return console.table ? console.table(_this.__performance__) : console.info(JSON.stringify(_this.__performance__, null, 2));
      };
    },
    componentWillMount: function componentWillMount() {
      this.performance('componentWillMount');
    },
    componentWillUnmount: function componentWillUnmount() {
      this.performance('componentWillUnmount');
    },
    componentWillReceiveProps: function componentWillReceiveProps() {
      this.performance('componentWillUpdate');
    },
    componentWillUpdate: function componentWillUpdate() {
      this.performance('componentDidUpdate');
    },
    componentDidMount: function componentDidMount() {
      this.performance('componentDidMount');
    },
    componentDidUpdate: function componentDidUpdate() {
      this.performance('componentDidUpdate');
      this.profile();
    }
  };
}