'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = pureStamp;

var _reactStamp2 = require('react-stamp');

var _reactStamp3 = _interopRequireDefault(_reactStamp2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function isRequiredUpdateObject(o) {
  return Array.isArray(o) || o && o.constructor === Object.prototype.constructor;
}
function deepDiff(o1, o2, p) {
  var notify = function notify(status) {
    console.warn('Update %s', status);
    console.log('%cbefore', 'font-weight: bold', o1);
    console.log('%cafter ', 'font-weight: bold', o2);
  };
  if (!_lodash2.default.isEqual(o1, o2)) {
    console.group(p);
    if ([o1, o2].every(function (o) {
      return typeof o === 'function';
    })) {
      notify('avoidable?');
    } else if (![o1, o2].every(isRequiredUpdateObject)) {
      notify('required.');
    } else {
      var keys = _lodash2.default.union(Object.keys(o1), Object.keys(o2));
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var key = _step.value;

          deepDiff(o1[key], o2[key], key);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
    console.groupEnd();
  } else if (o1 !== o2) {
    console.group(p);
    notify('avoidable!');
    if (_lodash2.default.isObject(o1) && _lodash2.default.isObject(o2)) {
      var _keys = _lodash2.default.union(Object.keys(o1), Object.keys(o2));
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = _keys[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _key = _step2.value;

          deepDiff(o1[_key], o2[_key], _key);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
    console.groupEnd();
  }
}

var freezeValue = function freezeValue(value) {
  return { value: value, enumerable: true, writable: false, configurable: false };
};

/**
 * Creates an optimized pure compose function with dependencies tacked onto it for easy lib propagation.
 * @param  {Object}         options.React           React dependency.
 * @param  {Object}         options.shallowCompare  React shallowCompare add-on dependency.
 * @param  {Array<Object>}  options.deps            Optional dependencies to propagate.
 * @param  {Object}         defaults                Optional configuration object to propagate.
 * @return {function}                                 pure compose function with propagated dependencies and defaults.
 */
function pureStamp() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      React = _ref.React,
      shallowCompare = _ref.shallowCompare,
      deps = _objectWithoutProperties(_ref, ['React', 'shallowCompare']);

  var defaults = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var PropTypes = React.PropTypes,
      cloneElement = React.cloneElement;

  var _reactStamp = (0, _reactStamp3.default)(React),
      compose = _reactStamp.compose;

  var pureDesc = { displayName: 'PureComponent',
    shouldComponentUpdate: function shouldComponentUpdate(nextProps, nextState) {
      return shallowCompare(this, nextProps, nextState);
    }
  };

  var profileDesc = {
    componentDidUpdate: function componentDidUpdate(prevProps, prevState) {
      deepDiff({ props: prevProps,
        state: prevState
      }, { props: this.props,
        state: this.state
      }, this.constructor.displayName);
    }
  };

  function _pure() {
    for (var _len = arguments.length, desc = Array(_len), _key2 = 0; _key2 < _len; _key2++) {
      desc[_key2] = arguments[_key2];
    }

    return compose.apply(undefined, [pureDesc].concat(desc));
  }
  function impure() {
    return compose.apply(undefined, arguments);
  }
  function profile() {
    for (var _len2 = arguments.length, desc = Array(_len2), _key3 = 0; _key3 < _len2; _key3++) {
      desc[_key3] = arguments[_key3];
    }

    return compose.apply(undefined, [pureDesc, profileDesc].concat(desc));
  }
  function impureProfile() {
    for (var _len3 = arguments.length, desc = Array(_len3), _key4 = 0; _key4 < _len3; _key4++) {
      desc[_key4] = arguments[_key4];
    }

    return compose.apply(undefined, [profileDesc].concat(desc));
  }
  var pure = Object.entries(_extends({ React: React,
    PropTypes: PropTypes,
    cloneElement: cloneElement
  }, deps, { defaults: defaults,
    impure: impure,
    profile: profile,
    impureProfile: impureProfile,
    destructure: function destructure() {
      return [_extends({ React: React, shallowCompare: shallowCompare }, deps), defaults];
    }
  })).reduce(function (pure, _ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
        depName = _ref3[0],
        dep = _ref3[1];

    return Object.defineProperty(pure, depName, { value: dep, configurable: false, enumerable: true });
  }, _pure);
  return Object.freeze(pure);
}